package edu.lawrence.canvasdemo

import androidx.compose.ui.geometry.Offset
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.graphics.drawscope.DrawScope

class Vertex(var centerX : Float,var centerY : Float) {
    val radius = 20.0f

    fun drawIn(scope: DrawScope) {
        scope.drawCircle(color = Color.Red, radius = radius,
            center = Offset(x = centerX , y = centerY))
    }

    fun containsPoint(pt : Offset) : Boolean {
        val deltaX = (centerX - pt.x)
        val deltaY = (centerY - pt.y)
        val r = 1.5*radius
        val distSquared = deltaX*deltaX + deltaY*deltaY
        return distSquared < r*r
    }
}

class Edge(var origin : Vertex,var dest : Vertex) {
    fun drawIn(scope: DrawScope) {
        scope.drawLine(
            color = Color.Green,
            start = Offset(x = origin.centerX, y = origin.centerY),
            end = Offset(x = dest.centerX, y = dest.centerY),
            strokeWidth = 3.0f
        )
    }
}